JT Import Converter - Main Table of Contents

Okino JTâ Assembly & Parts CAD Import Converter

Quick Jump:

Visual snapshot index of each import converter panel

Overview

This help file describes the Okino "JT" import converter module which allows geometry, hierarchy and materials (assembly data) to be imported from native .jt disk based MCAD files (otherwise called "DirectModel" files). The JT importer is built upon the official "JT Open" toolkit which has been licensed from Siemens Corp. The use of the official "JT Open" toolkit ensures consistency of JT files across the enterprise and throughout the PLM market.

"Buggy" JT model from the JT-Open Showcase

What is JT?

"JT", the predominant and lightweight 3D visualization file format for PLM, is in production use by thousands of companies worldwide. Compact and accurate, JT is used throughout the product development lifecycle in all major industries to communicate the critical design information typically locked up inside a CAD file.

The JT data representation is:

· A rich data model with robust entity support.

· A high-performance, compact persistence archive format for graphics data.

· The best-in-class for supporting large assembly / model interactive capabilities.

· CAD-neutral supporting all major MCAD applications.

JT data can be very lightweight, holding little more than facet data or it can be richer and hold associations to the original CAD information, assemblies, product structure, geometry, attributes, meta data and PMI. It supports multiple tessellations and level-of-detail generation.

Related WEB Sites

"JT Open", http://www.jtopen.com

Main WEB site for the "JT Open" initiative

"JT2Go", http://www.jt2go.com

View JT files, or embed JT files in Microsoft Office documents.

See Also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Features of the JT Import Conversion System

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

JTâ is a registered trademark of Siemens Corporation. All other brand names, product names or trademarks belong to their respective holders.


Visual Snapshot Index of Each Import Converter Panel

Click below for help on any JT import converter panel:

Intro Panel | Beginner/Expert Mode | Beginner Precision
Expert Precision | Expert Precision # 2 | Material Import
Material Tweaks | Extracted Texture Locations | Scaling & Meta Data
Tessellation Options |  |


Features of the Import Conversion System

Features of the JT Import Conversion System

· Allows for the transfer and import of complex MCAD datasets from upstream application packages, used typically by large corporate users.

· Imports and retains: assembly hierarchy information and assembly structure of the source model. Can query accurate vertex normals, uv texture coordinates and UV tangent vectors (when available).

· The only known implementation of a JT importer which provides support for re-tessellating the file’s JT BREPs or Parasolid XT BREPs on the fly using the official Siemens JT BREPs tessellator (for the NURBS or solids MCAD geometry). The basic premise of the JT file format is that the BREPs/NURBS/solids tessellation process is to be done by the program which creates and writes out the JT file so that loading of the JT file is very fast. However some of our users have the requirement that the BREPs geometry be re-tessellated upon import so that they can control the final polygonal mesh quality, density and/or curvature. The Okino JT importer provides a professional implementation whereby the surface deviation, curvature deviation and/or maximum edge length can be easily controlled via 3 sliders. Hence, the JT importer allows for either the import of the pre-tessellated polygon geometry (which was provided along with the file data) or for the re-tessellation of the original BREPs/NURBS/solids MCAD geometry.

· The choice of imported LOD levels can be controlled through various sliders.

· Okino's "CAD Scene and Hierarchy Optimization System" has been integrated right into the JT importer. This is most important when importing large CAD models into 3ds Max, Maya, Cinema-4D, Unity, Unreal, Lightwave and other down-stream 3D programs. These 3D packages tend to have performance problems then the source CAD model is large, and/or has a large number of individual parts (which is often the case with the BREP model topology of data provided by JT).

· The native PolyTrans plug-in systems for 3ds Max (PolyTrans-for-3dsMax) and Maya (PolyTrans-for-Maya) have been refined since 1996 specifically for importing large CAD assembly models from JT. This has come about partly from our good software users, and also from the main Okino CAD programmers who have been specializing in CAD to non-CAD conversion software since 1988.

· Complete control over material parameter modification on an automatic basis. Many MCAD file formats like JT have basic material parameters (like color, ambient + diffuse shading coefficients, opacity, etc) but when they are transferred over to a rendering and animation system they often look "too bright" or "highly ambient". This can be expected and is quite normal. The material tweak parameters easily allow such saturated shading values to be automatically compensated.

· Extracts embedded texture images from the JT file and saves them to TIFF files. The resulting TIFF files are then linked to the materials as diffuse texture maps.

· Extraction of 3D Product Manufacturing Information (PMI) data, also known as 3D GD&T, from the JT file. PMI data will be extracted into the 3D scene as polyline and polygon information, stored under "PMI" grouping nodes in the scene. Text and vector data will be converted to 3D polyline primitive data.

· Extraction of meta data (and hidden meta data items) in parts and assemblies.

See Also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


The File Import Process Using Okino's PolyTrans Or NuGraf

Once PolyTrans/NuGraf and the JT plug-in have been installed, a typical import process proceeds as follows (the process is similar when importing directly into 3ds Max or Maya directly):

· From the NuGraf File/Import menu, or the PolyTrans Translate!/Import menu, select "JT-Open File...".

· The JT import wizard appears inside the NuGraf or PolyTrans software, showing the Intro Panel. The "Next" button is pressed.

· The Beginner/Expert Mode panel appears next. This allows you to choose between further panels which are suitable for beginners, or for experts who want ultimate control over the import conversion process. We suggest you always use the expert mode.

· If the beginner mode is selected, then the next panel will show the Beginner Precision options. This panel determines what type of geometry attributes are imported (vertices, normals, tangents or auto-computed normals) as well as how many polygons will be used to approximate the parametric solid surfaces of the JT file (the surface tolerance deviation). Clicking the "Next" button will advance to the last panel of this introduction (the Errors & Stats panel).

· If the expert mode is selected, then the next panel will show the Tessellation options. This panel determines whether the imported geometry will be sourced from the pre-tessellated polygon mesh data of the JT file or whether the original MCAD BREPs/NURBS/solids geometry will be re-tessellated on the fly to a new polygonal mesh dataset.

· The next expert level panel will show the first of two Expert Precision options. This panel determines which LOD (level of detail) will be imported for each object, and the quality of tessellated parametric surfaces. It also provides a checkbox to enable the import of PMI graphical data.

· The next expert level panel will show the second of two Expert Precision # 2 options. This panel will allow you to further refine which polygon attributes are imported, as well as allowing the scene to be flipped so that the Y axis is "Up".

· The second last expert level panel will show the Material Import options panel. In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from the JT file so that they will render properly in the destination rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter.

· The last panel is the Measurement Units & Statistics panel. This presents some options to control how import converter errors are handled, and whether statistics should be displayed after the import process is completed. It also provides two drop-down combo boxes which allow the imported data to be scaled up in size or scaled down in size, as well as automatically scaled to match the source and destination scaling units. The "Hierarchy Optimization" checkbox will allow you to enable an optimizer which can greatly reduce the number of objects and hierarchy nodes in the imported scene.

Once the import wizard goes away, the 3D model data in the JT file is tessellated into polygons and transferred into Okino's software. The process completes once the entire model has been imported.

See also:

Visual Snapshot Index of Each Import Converter Panel


Runtime Suggestions

This short section explains the most fundamental and important suggestions that we pass on to users of the JT CAD importer. This section is accessible by pressing the "Suggestions…" hyperlink found on some of the importer wizard panels.

"Hierarchy Optimization" Suggestions

· This option can make all the difference between importing a huge CAD model quickly, with little memory usage and the fewest objects verse importing it slowly. This command will collapse all children objects inside a grouping folder to a single object, and remove extraneous hierarchy folders. It can have profound results, in particular, for CAD models imported into 3ds Max, Maya and Lightwave.

Scaling of the Model Suggestions

· Model scaling is an important, yet often overlooked aspect of the CAD import process by our users.

· In a nutshell, you should make sure your imported model generally ranges from 1x1x1 to 1000x1000x1000 units in size. Often we see customers importing a model which is only 0.001 units across - most downstream programs do not have the accuracy to display, render or manipulate such small models. Ditto on the model being too large (e.g. 1 million units wide).

· After your first file import use the destination program to determine the overall width, height and depth of the model, in general scaling terms. This can often be done by moving the cursor across the model and watching the current "XYZ Location" status bar message. If the model is too large, re-import it and change the Additional Scaling To Apply type-in box to a number such as 0.1, 0.01 or 0.001 (10x, 100x and 1000x times smaller). If the model is too small, re-import it and change the Additional Scaling To Apply type-in box to a number such as 10, 100 or 1000 (10x, 100x and 1000x times larger).

General Suggestions

· Always choose the Expert Mode so that you can control all the options discussed above.

See also:

Main Index Page of This Online Help System


Intro Panel Options

This is the first panel which appears once the JT import converter has been loaded.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Beginner/Expert Mode Options

This second panel determines whether subsequent panels will show simpler beginner options, or a variety of more complex options for expert users. Click on the telephone image for beginner mode, or the video camera for expert mode. We recommend the expert mode.

If you want to reset all of the import converter options to the default start-up values, then check-mark the "Reset import parameters before continuing" check box before pressing the "Next" button.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Beginner Precision Options

For beginners, this is one of the most important import converter panels. It determines "how much" data, how accurately the object data from the JT file is converted to polygons, and how quickly the import process proceeds.

"Data Completeness" Slider

This slider determines which type of data is actually imported from the JT file. Setting the slider all the way to the left will import the least attributes associated with the model, while setting the slider all the way to the right will import the most attributes possible.

Minimum - Import polygon data only. The imported data will appear faceted due to the lack of vertex normals.

Some - Import polygons and vertex normals (smoothing info). This is useful is you want the imported objects to appear smooth, but you do not want to import uv texture coordinates for texture mapping or UV tangent vectors for bump mapping.

Most - Import polygons, vertex normals and uv coordinates. This is useful is you want the imported objects to appear smooth, and to have default texture coordinates.

All - Import polygons, vertex normals, uv coordinates and tangent vectors. Same as above except that tangent vectors will be useful for adding bump mapping to objects via texture maps.

"Surface Precision" Slider

Data inside JT files can be represented as "solids" or NURBS surfaces. When importing these parametric surfaces into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the left, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the right then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Expert "Pre-tessellated Polygons vs. Post-Tessellated NURBS/Solids/BREPs" Options

A fundamental premise of using the JT file format within the MCAD industry is that the 3D software program which creates the JT file does all of the NURBS/solids/BREPs "tessellation" to a polygonal mesh representation during the file export process. Hence, the loading of such resulting JT files into a destination 3D program is very fast since no further tessellation has to be done during the import of the JT data – rather, the pre-tessellated polygonal mesh objects are loaded and imported immediately.

However, on the flip side, many JT files contain both the pre-tessellated polygon mesh of the scene as well as the original NURBS/solids/BREP MCAD geometric data (in the "JT BREP" or "PARASOLID XT BREP" format). Some people may have the desire to re-tessellate the internally embedded NURBS/solids/BREP geometric data at a different polygonal tessellation quality.

As such, this dialog box basically allows you to choose between importing the pre-tessellated polygon mesh data or having the internally embedded NURBS/solids/BREP geometric data re-tessellated to triangular polygons at a different quality level.

For those that are not familiar with this terminology:

· Most non-MCAD programs define 3D geometric objects using triangular polygons. This will appear to be a "soup" of triangles to someone looking at its wireframe representation.

· However, in the MCAD world, all major MCAD "solids" modelers define geometric objects using an abstract mathematical concept called NURBS or "BREP solids". You can think of this as creating geometric objects using a virtual rubber sheet which is bent, cut and deformed into the shape of a portion of the final geometry. However, non-MCAD programs (such as many 3D animation programs) cannot import and display such parametric (mathematically defined) forms of geometry. Instead, these NURBS/solids/BREPs surfaces need to be converted into a 3D polygonal representation using a process called "tessellation". How accurate that final polygonal representation will be to the original "mathematically precise" NURBS/solids/BREPs surface representation is controlled via the following 3 sliders. Moving the sliders more to the left will create a more precise tessellation but at the added cost of many more triangular polygons.

Geometry Data Source:

As explained above, JT files can often have both a pre-tessellated polygonal mesh representation of the geometric objects as well as the original NURBS/solids/BREPs surface data. This combo box chooses the preference of one over the other during the import process.

Import pre-tessellated polygons from the JT file

This option, which is the default, will cause the pre-tessellated polygonal mesh representation of the geometric objects to be imported (as had been written out by the program which had originally created the JT file). This is the fastest import method.

Import BREPs (solids & NURBS), BY BODIES, and re-tessellate to polygonal meshes

This option will opt to import the NURBS/solids/BREPs surface data for each object definition and then tessellate them to a corresponding polygonal mesh representation on the fly. The quality of the resulting polygonal mesh is controlled through the 3 sliders. This method can be much slower than when importing from the pre-tessellated polygonal mesh representation (but especially when you lower the value of any or all of the sliders).

Import BREPs (solids & NURBS), BY FACES, and re-tessellate to polygonal meshes

[If this option is presently not available in the drop-down combo box then it has been temporarily removed while Siemens Corp. addresses face-level tessellation issues with their official ‘JT Open’ toolkit].

This option is identical in its nature and execution to that of the prior combo box option except that the tessellation is done on a "Face by Face" basis rather than on a "BREP by BREP" or "Body by Body" basis. In less technical terms, this combo box option tessellates each geometry entity "bit by bit" at its smallest internal component level whereas the prior option (body by body) tessellates the entire geometric object as a whole.

In general terms you should not need nor use this "Face by Face" tessellation method. It is only provided as a fall-back mechanism just in case the "Body by Body" tessellation method fails on some of the geometry objects.

If this option is not available within the combo box then it has either been deprecated or temporarily disabled on the suggestion from Siemens Corp.

Tessellation Quality Sliders

Surface Deviation

This slider controls how smooth the final surface will appear.

Lower values will make the surface smoother but at the expense of a longer tessellation time and more resultant polygons.

This slider represents the maximum allowable distance (tolerance) between the true solids surface and that of the tessellated triangulated surface. The lower the value, the more the tessellated surface will approximate the real 3D surface. The value is measured as a percentage of each model’s bounding box "diagonal" dimension.

Note: this surface deviation tolerance is applied by the tessellation algorithm before the curvature deviation tolerance is taken into account.

0.1% Surface Deviation

0.5% Surface Deviation

1% Surface Deviation

2% "Maximum Edge Length" only

Curvature (Normals) Deviation

This slider controls how smooth curves will appear cut into the surface or along boundaries (such as trim holes or face boundaries).

Lower values will make curved areas smoother but at the expense of a longer tessellation time and more resultant polygons.

This slider represents the absolute maximum angle between two adjacent line segments in a curve approximation. The value is measured in degrees. The default is 15 degrees and you should not go much above 45 degrees. The lower you drop this value the slower the tessellation process will take and the more polygons/triangles that will be created.

Curvature Deviation = 5 degrees

Curvature Deviation = 15 degrees

Maximum Edge Length

This can be considered a "specialty" tessellation control parameter. When set appropriately it can be used to make the resultant triangular network of polygons appear to be "squarish" (or quad-like as some animators prefer to use with their imported MCAD datasets).

Please note that Siemens (developers of the 'JT Open' toolkit) consider edge-length based tessellation to be a legacy aspect of their software. It can be used to create squarish-aspect polygons but the resulting mesh consistency may vary. Hence, please use at your own discretion.

This slider sets the maximum allowable length of the edges as computed from the "Surface Deviation" based tessellation. As this edge length is made smaller it will force a higher density of polygons to be computed with the benefit of such polygons/triangles becoming more square in their aspect ratio.

The Siemens ‘Open JT’ toolkit requires that this parameter be set in absolute geometry-space coordinates which is very difficult for most anyone to do easily. Rather, it has been implemented in this Okino importer so that this parameter is set as a percentage of each object’s geometry-space bounding box diagonal – in other words, this parameter adapts to the size of each object being tessellated on the fly.

Choosing an appropriate ‘Maximum Edge Length’ can be very much dependent on the geometry on hand which is to be tessellated. Based on Okino’s personal experience this value has been defaulted to a sane starting value which hopefully won’t create too many or too few polygons. If you wish to tweak this slider then we recommend either increasing or decreasing it by a factor of either 2, 5, or 10.

Note: using the "BY-FACES" option requires that the 'Surface Deviation' or 'Curvature Deviation' slider be enabled when the 'Maximum Edge Length' slider is enabled.

0.1% Surface Deviation & 15 degrees Curvature Deviation

0.1% Surface Deviation & 5% "Maximum Edge Length"

NOTE: If you want to set a value higher or lower than allowable via the slider then just type in that number to the type-in box.

NOTES:

1. If JT or PARASOLID XT BREPs (NURBS geometry surfaces) are found in the imported JT file then their counts will be printed in the final import statistics. If only pre-tessellated polygonal geometry is found (and not JT or XT BREPs) then no counts will be output.

2. To create squarish-aspect triangles, disable the 'Surface Deviation' & 'Curvature Deviation' sliders then choose an appropriate maximum 'Maximum Edge Length' (percentage of bounding box). Note: using the "BY-FACES" option requires that the 'Surface Deviation' or 'Curvature Deviation' slider be enabled when the 'Maximum Edge Length' slider is enabled.

3. The polygonal LODS (levels of detail nodes) defined within the JT file will be ignored if and when the NURBS/solids/BREPs are chosen to be imported instead.

4. If the tessellation of any object fails then the original pre-tessellated triangular mesh will be imported instead for that object (as well as any LODs if they are selected for import).

5. If you find, via the message window and final import statistics, that 1 or more "Bodies/BREPs" have failed during their tessellation then you can try using the alternative "BY FACES" option provided on the drop-down combo box (see explanation above).

See also:

A warning to 3ds Max and Maya users about Possible PARASOLID DLL mismatches


A warning to 3ds Max and Maya users: Possible PARASOLID DLL mismatches

A Warning to 3ds Max & Maya Users About Possible PARASOLID DLL Mismatches

The following explanation can be most confusing to our 3ds Max and/or Maya users, at first, so please read through this overview carefully. It will be important to ensure that the XT & JT BREP "on the fly" tessellation functionality works properly.

What is the problem, in short?

When Okino software and our JT importer is run within 3ds Max (via Polytrans-for-3dsMax) or within Maya (via PolyTrans-for-Maya), it is possible for the wrong version of the Siemens PARASOLID runtime system (DLLs) to be invoked.

This may then give you the incorrect impression that the process fails, locks up or has other issues.

If you find that a JT BREP "on the fly" tessellation works within the stand-alone Okino software but not similarly within 3ds Max or Maya then this is the basic reason why.

What is the problem, in greater detail?

Okino licenses the official "JT Open" toolkit and SDK from Siemens Corp. We always use the newest version whereas the version embedded within Autodesk software can be upwards of 1 to 10 years old. There lies the problem…

The Okino licensed version of JT and its various JT/PARSOLID DLLs are stored in the Okino home directory (which will often be "c:\program files\polytrans64" or "c:\program files\nugraf64").

When the JT importer is invoked within 3ds Max or Maya, Microsoft Windows load ups the older versions of the Siemens JT and PARASOLID DLLs, from the following directories, rather than from the newest versions located in the Okino home directory:

Maya\plug-ins\ATF\ATF

3ds Max\atf_converter

How to fix this runtime problem?

The simple fix is to prevent Microsoft Windows from locating and loading up these older Siemens DLLs (within 3ds Max or Maya) and hence allowing Windows to go search further for them, eventually finding them in the Okino home directory. This is how Okino software was always defined to run and work within 3ds Max and Maya.

What you will want to do is:

1. Navigate to either of these two directories on your computer using Windows Explorer:

Maya\plug-ins\ATF\ATF

3ds Max\atf_converter

2. Then use a program such as WinZIP to ZIP up and remove the following DLLs from the aforementioned directory:

psbodyshop.dll

pskernel.dll

psxttoolkit.dll

3. To be 100% safe, you can also include the following files in your ZIP file. On your machine the DLLs will most likely have different version numbers as defined by the ‘???’.

jt???.dll

jttk???.dll

parasupt???.dll

4. Thereafter, once you are done, these aforementioned DLLs should no longer be located in the 3ds Max or Maya directory. This will ensure that the Okino versions of these DLLs are loaded up at runtime within 3ds Max or Maya.

5. All of this work should take less than 1 or 2 minutes.

See also:

Expert "Pre-tessellated Polygons vs. Post-Tessellated NURBS/Solids/BREPs" Options


Expert Precision Options

This is the first expert mode options panel which controls "how much" data is imported from the JT file.

"Level of Detail" Slider

JT files can have the same object embedded in the file at different "levels of detail" (LOD). Each LOD provides a representation of the object at varying mesh resolutions. For example, a car could be embedded in the file using a mesh resolution 100 polygons, 1000 polygons and 100,000 polygons. Application programs often use LODs to display the model at high resolution when the camera is close to the object, or display it at the lowest resolution when the camera is far away from the object.

This slider determines which LODs of each model are to be imported. If set to 100% then the highest quality models will be imported (those with the most polygons). If set to 0% then the lowest quality models will be imported (those with the fewest number of polygons).

Not all JT files have LODs in them, so this slider will not affect such files.

Import Product Manufacturing Information (PMI)

3D Product Manufacturing Information (PMI) data, also known as 3D GD&T, is mark-up information in the JT file. If this checkbox is enabled then the PMI data will be extracted into the 3D scene as polyline and polygon information, stored under "PMI" grouping nodes in the scene. Text and vector data will be converted to 3D polyline primitive data.

PMI in this importer consists of:

· Geometric and linear dimensioning and tolerancing information.

§ Linear dimensions

§ Geometric dimensioning and tolerancing symbols

§ Datums

§ Datum targets

· Additional manufacturing information such as surface finish and weld information.

§ Surface finishes

§ Spot welds

§ Line welds

§ Measurement points

§ Locators

§ Notes

The following is a simple example of a JT file with PMI information.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Expert Precision Options # 2

Expert Precision # 2 Options

This expert mode options panel provides control over specialized aspects of the import process.

Optimize vertices to speed up import processing

If this check box is enabled then all duplicated (redundant) vertices of the imported data will be deleted before any normals, uv coordinates or UV tangent vectors are queried from the JT file.

Normal Attribute Processing (Pop-Down List Box)

This pop-down list box determines how vertex normals are to be created for the imported polygon data.

-Skip- No vertex normals will be imported. The imported polygon data will not appear smooth when rendered.

Generate - A smoothing algorithm in the import converter will be enabled to automatically create vertex normals based on smoothing angle. This will create only an approximation of the real vertex normals from the JT file. If this option is chosen then the "Smoothing Angle" text type-in box becomes enabled; higher values (near 90 degrees) will make your objects appear highly smoothed (no sharp corners) whereas lower values (around 15 to 20 degrees) will make your import objects appear more faceted, although smooth where they should be.

Import Only - The true vertex normals will be queried from the JT file one by one. This is much slower but produces more accurate results.

Import & Optimize - The same as "Import Only", but the vertex normals will also be optimized so that any redundant coordinates are deleted.

uv Texture Coordinates (Pop-Down List Box)

This pop-down list box determines how vertex uv texture coordinates are to be imported from the JT importer.

-Skip- No vertex uv texture coordinates will be imported. You will not be able to apply 2D bitmap textures to the imported objects without these uv texture coordinates.

Import Only - The true vertex uv texture coordinates will be queried from the JT file one by one.

Import & Optimize - The same as "Import Only", but the vertex uv texture coordinates will also be optimized so that any redundant coordinates are deleted.

UV Tangent Vectors (Pop-Down List Box)

This pop-down list box determines how vertex UV tangent vectors are to be imported from the JT file (if they exist).

-Skip- No vertex UV tangent vectors will be imported. You will not be able to apply 2D bitmap bump mapping textures to the imported objects without these tangent vectors.

Import Only - The true vertex UV tangent vectors will be queried from the JT file one by one.

Import & Optimize - The same as "Import Only", but the vertex UV tangent vectors will also be optimized so that any redundant coordinates are deleted.

Flip Model so that 'Y' Axis is 'Up'

By default the data is imported so that the 'Y' up axis in the JT coordinate system becomes the 'Y' up axis in Okino software. If this checkbox is enabled, then the imported data will be reoriented so that the 'Z' axis in the JT file becomes the 'Y' Up axis in Okino software.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Material Import Options

In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from the JT file so that they will render properly in the destination rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter. The default action is to not modify any imported material characteristics; however, you will often find that imported JT models appear "too ambient" or "too diffuse".

Import Method (Pop-Down List Box)

By default, three "material import processing" methods have been provided for you by clicking on the pop-down list box. You are also free to define your own methods by pressing the "New" button on the panel which will call up the Material Tweaks sub-dialog box:

Do Not Import Material Properties - No material properties will be imported at all.

Preserve Numerical Values - All materials will be imported from the JT files without any change or tweaking.

Preserve Appearance (Recommended) - The material shading coefficients will be set to the following values, ensuring that the model should look ok when rendered:

· Diffuse shading coefficient = 0.4

· Ambient shading coefficient = 0.3

· Specular shading coefficient = 0.7

· Highlight value = 0.12 (0 = wide highlight, 1.0 = narrow highlight)

· Emission (luminous) shading coefficient = 0

· Opacity (inverse of transparency) = 1.0 (fully opaque)

Extract Embedded Textures as New TIFF Bitmaps

If this checkbox is enabled then images embedded within the JT file will be extracted as TIFF images on disk. They will then be associated as diffuse texture maps with the corresponding object's material. The next panel controls where the textures will be stored on disk and what file path will be used to prefix the texture reference.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Material Tweak Options

This sub-dialog box provides ultimate control over how imported material properties should be modified so that the imported model can be rendered nicely in a photo-realistic rendering program. All too often the imported model appears "too ambient" or "too diffuse", resulting in rendered images that are washed out or with no gradual shading effects visible. By default you should use the "Preserve Appearance" pre-defined import method.

First, to add a new material processing method, press the "New" button on the Material Import panel. This will cause the sub-dialog box to appear in which you can set your custom material import processing options.

As an explanation of the various shading parameters listed on the sub-dialog box:

Diffuse: This controls the amount of color reflected from an object based on the direct light shining on it. A good default value is 0.4.

Ambient: This controls the amount of color reflected from an object based on the ambient light in a scene. A good default value is 0.1 through to 0.3.

Specular: This controls the intensity of the highlight on an object. A good default value is 0.7.

Highlight: This controls the width of the specular highlight on an object (0 = wide, 1.0 = very narrow). A good default value is 0.12.

Emission (luminous): This controls how much color is added to an object, irrespective of any light which shines on it (the higher the value, the more the object will appear to glow). In general you should keep this value at 0.

Opacity: This is the inverse of transparency. 0.0 will make the object fully transparent, while at 1.0 the object will be fully opaque.

For each material property, several actions can be performed on it during the import from the JT file. Two sets of actions are provided, that which is performed when the diffuse color values is being imported and those which are performed when all other parameters other than diffuse are being imported.

The actions taken when importing the diffuse color value are described as follows:

- Skip - : The diffuse color value is not imported (no color change is made).

Use Default Coefficient: This action imports the diffuse color with no change made at all, but the diffuse shading coefficient for the color will be set to a "pleasant" value resulting in 3D scenes which render "photo-realistically" (in other words, without harsh or overly bright colors). This coefficient typically ranges from 0.3 through to 0.5. The "coefficient" mentioned here is the same as the "Shading Coefficients" on the "Color" surface attribute editor in Okino’s NuGraf software.

Set Coefficient To: This behaves the same as "Use Default Coefficient" except that the diffuse shading coefficient for the diffuse color is set to a user specified value. Let’s assume you set this shading coefficient to 1.0 (the worse case); this would result in a rendered scene which was over saturated in diffuse color. To circumvent this problem (as is done in all 3D rendering packages), we "attenuate" the diffuse color by a specific percentage so that it won’t saturate the final rendered image when the shading is done.

Normalize Color and Coefficient: This is a hybrid approach which tries to automatically "guess" at proper diffuse shading coefficient values using the raw diffuse color imported from the JT file. As mentioned, this shading coefficient is needed to create nice looking (nicely shaded) images in a photo-realistic rendering program. If this drop-down box option is chosen, then the diffuse shading coefficient will be derived directly from the relative intensity of the imported diffuse color. For example, if the imported diffuse color is (0.4, 0, 0), which is 40% of full-bright red, then the diffuse shading coefficient will be set to 0.4 and the diffuse color will be modified to be (1, 0, 0). When the new color (1,0,0) and the new shading coefficient (0.4) are multiplied together, it results in the original color imported from the JT file (0.4, 0, 0). In general you may wish to use the "Use Default Coefficient" option to get good rendered results.

The actions taken when importing all parameters other than "diffuse" are described as follows (highlight value and opacity):

- Skip - : The material parameter is ignored during import.

Import Unchanged: The material parameter is imported as is, with no change.

Unconditionally Set To: The material parameter is not imported but rather it is set to the numeric value on the dialog box.

Import and Crop by: The material parameter is imported and remains unchanged if it is less than the numeric value on the dialog box. If it is greater, then the imported value will be clamped to be no greater than the numeric value on the dialog box.

Import and Scale by: The material parameter is imported and scaled by the numeric value on the dialog box.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Location for Extracted Texture Maps Options

If the "Extract Embedded Textures as New TIFF Bitmaps" is enabled on the Material Import dialog box then this panel will appear next. It defines where the extracted bitmap images will be placed on disk.

Location To Store Extracted Texture Maps

This UI control determines the location to where the extracted TIFF texture maps from the JT file will be written. By default they will be placed in the same directory as the source JT file. If you wish to choose a new location then press the "…" button

Set All Texture File Paths To…

This UI control allows the file path on the texture image to be changed. The options are either to keep it untouched, to strip the file path from each texture map reference, or to replace it with a new file path. Press the "…" button to choose a new texture file prefix path.

Display Textures While Extracting From Geometry Files

If this checkbox is enabled then images embedded within the JT file will be displayed on the user interface while they are being extracted from the file. This only applies to Okino's standalone PolyTrans and NuGraf programs.

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


Errors and Statistics

Units Matching & Meta Data

One of the primary uses of this panel is to set up the "units matching". Data from a JT file comes across the conversion pipeline in terms of "meters". However, the destination 3D program may not be using meters as its default measurement units. For example, 3ds max uses "inches" by default, Lightwave uses "cm" and Maya uses "meters". The combo boxes on this panel allows the measurement units to be matched, as well as additional scaling to be applied to the imported geometry data.

Hierarchy Optimization

Enabling this option will collapse hierarchies of hundreds of parts into many fewer parts, making the import of large and complex assemblies possible for programs such as 3ds Max, Maya, Lightwave and others (non-CAD programs which suffer in terms of performance for assemblies with large numbers of objects). The documentation for the "Hierarchy Optimization" option can be viewed by pressing the "Options…" button and then the "Help" button on the optimizer's dialog box. If the JT file does not contain grouping nodes then this processing will not affect the imported file.

Data Scale

"Units conversion" is often an important aspect of importing CAD files. People who create 3D models in a modeling package will do so using a specific units system, such as meters or feet. However, when these models are imported into another 3D package that uses a different default units system (such as Lightwave which uses centimeters), a "units conversion" operation needs to occur (the imported model geometry needs to be rescaled).

This import panel determines what will be done when the units defined in the JT file do not match current internal system units. If the units do not match, the JT importer will rescale the imported geometry based on the ratio between the JT units and the internal system units.

Unit of Measurement

You need to set this combo box to the measurement units system in effect for your destination 3D program. For example, set it to centimeters for Lightwave, inches for 3ds Max, centimeters for Maya, etc.

If you are importing into the Okino PolyTrans or NuGraf programs then you can either set the destination units measurement system via this combo box or set the combo box to "Current System" and then set the measurement system inside the main PolyTrans/NuGraf program (Edit/Preferences/Startup Preferences/Other/System Units).

Ignored | No units; never do any geometry scaling
Current System | Scale data to match current internal Okino units
Use Document | Set Okino units to the file’s units. No scaling done
Microinches | 1e-6 inches
Mils | 1e-3 inches
Inches | 2.54 centimeters
Feet | 12 inches
Yards | 36 inches
Miles | 1.6 kilometers
Microns | 1e-6 meters
Millimeters | 1e-3 meters
Centimeters | 1e-2 meters
Decimeters | 1e-1 meters
Meters | 3.28 feet
Kilometers | 0.62 mile
Custom | Custom units are in effect

If the "Custom" option is chosen then the numeric value contained in the "Additional scaling to apply" edit control defines the "units per meter" scale factor for a custom unit system. For example, if you were to enter "0.62" into the type-in box then this would be equivalent to the "Kilometers" units measurement system.

Additional Scaling to Apply (Combo Box)

This drop-down combo box allows imported geometry to be scaled up or down in size by units of 10, 100 or 1000 times. You are free to enter your own scaling factor into the type-in portion of the combo box if you wish (such as "5000"). If you created your model within the source modeller using "millimeters", for example, then the model will appear about 1000 times too small when imported into the destination program. The solution is to select a scaling option on this wizard panel appropriate for the size of the data as it appears in the source modeling program. For example, if you model in millimeters within the source modeling program then you will want to scale up by 1000 units so that the imported model will not look tiny.

NOTE: If the "Unit of Measurement" combo box is set to "Custom" then the "Additional scaling to apply" edit control defines the "units per meter" scale factor and not an absolute scaling factor.

Import Meta Data

Enabling this option will import any meta data found on JT parts. Such data can then be re-exported to Okino converters which support meta data. String, integer, float and date JT meta data will be imported.

Meta data marked with "hidden visibility" within the JT file will not be imported unless the "Include hidden metadata items" checkbox is enabled.

Runtime Import Options

Tolerate File Integrity Errors

If this option is enabled then the converter will not stop if it receives unexpected data as a result of a data query to the JT Open toolkit; in this case the import converter will just skip over that element and continue importing.

Report Statistics About the Imported File

If this check box is enabled then statistics will be reported after the data has been imported.

Merge Triangles To Quads, Max Angle = #

All top-6 MCAD programs since the invention of NURBS in the 1980’s, always output triangular meshes and not quad meshes. This is because quads cannot accurately represent the curvature of NURBS surfaces.

This option is a post-processing step that merges triangles back to quadrilateral polygons (4 sided polygons). The number of vertices remain the same but the overall number of polygons are reduced.

If this option is enabled (check marked) then an algorithm will be invoked which merges multiple polygons into quads. If two adjacent triangles are nearly co-planar then they will be turned into a quadrilateral. The vertices of the adjacent edges must be welded together (shared) for this operation to proceed properly.

The test for co-planar polygons (polygons which are almost on the same plane as each other) is determined by the "Max angle" type-in box. This value is measured in degrees. Values near 0 will require that adjacent polygons be very much co-planar with each other, while higher values will allow polygons that meet at an angle to be considered. For example, if you have a curved object made of triangles then try setting the angle to 4 to 7 degrees. Higher values will allow more polygons to be merged.

NOTE: you can also apply this merging algorithm via the "Polygon Processing" functionality found in the stand-alone Okino software. On that dialog box you would invoke the "Merge Co-Planar Polygons into larger polygons" function. That alternative version also provides some more controls over whether vertex normals, vertex colors and vertex uv’s are to be taken into account (they are all taken into account when invoked via the polygon reduction system).

See also:

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf


AFX_HIDP_default

No Help Available

No help is available for this message box.

<< If you wish to author help specific to each message box prompt, then remove the AFX_HIDP_xxx values from the [ALIAS] section of your .HPJ file, and author a topic for each AFX_HIDP_xxx value. For example, AFX_HIDP_INVALID_FILENAME is the help topic for the Invalid Filename message box. >>


HID_HELP


HID_HT_NOWHERE

No Help Available

No help is available for this area of the window.


HID_WIZBACK


HID_WIZFINISH


HID_WIZNEXT


HIDC_ANGLE

This value controls the smoothing criterion used when normals are being generated (as opposed to being queried from the server). It is based on the angle between abutting polygons; common smoothed vertex normals will be computed if the angle between their geometric surface normals is less than the angle specified.

Defaults to 45 degrees. Increase this value if the imported object appear to have overly rough surface. Decrease this value if the surface appears to be overly smoothed.


HIDC_BANNER


HIDC_BEGINNER


HIDC_BODIES


HIDC_ERROR_TORERANT


HIDC_EXPERT


HIDC_FACES


HIDC_FLIP_Y_UP

If this option is enabled then the model will be rotated so that its Up axis is aligned with the positive Y-axis instead of the positive Z-axis.


HIDC_NORMALS


HIDC_OPEN_CURRENT


HIDC_OPEN_FILE


HIDC_OPTIMIZE_VERTICES


HIDC_REPORT_STATS

If this checkbox is enabled then the import converter will print out the number of objects, polygons, normals, texture coordinates, tangent vectors and surfaces that were parsed from the SAT file.


HIDC_RESET_DEFAULT


HIDC_TANGENTS

If this checkbox is enabled then the import converter will import proper tangent vectors for each triangle vertex. Tangent vectors are necessary if bump map texture image is to be applied to the object at some time in the future.


HIDC_UV

If this checkbox is enabled then the import converter will import proper texture (u,v) coordinates for each triangle vertex. Texture coordinates are necessary if a bitmap texture image is to be applied to the object at some time in the future


HIDP_INVALID_PATH

Invalid Path

HIDP_INVALID_PATH